#ifndef __FUNCTION_H__
#define __FUNCTION_H__

#include "shaunlib.h"
#include "haplotype.h"
#include "model.h"
#include "driver.h"

class CFunction : public CFunction_ABC 
{
public:
  
  CFunction(CSample &, Model&, Driver &);

  CSample & sample;
  Model & model;
  Driver & driver;
  
  // Must be called 'func'
  double func(CVector& p);

  // Helper functions
  double calculateExpected();
  double calculateVariance();
  long double calculateLikelihood(CIndividual *);
  
  // Class variables
  double constant,resvar;
  CColVector bet_beta;
  CColVector with_beta;
  CColVector freq_beta;
  CVector cbeta;
  
  CIndividual * proband;

  int nphase;

  double false_ind_denom;
  double true_ind_denom;
  double false_trio_denom;
  double true_trio_denom;

}; 
#endif
