#include "window.h"
#include "driver.h"
#include "parameters.h"

int Window::n = 0;
int Window::end = 0;
int Window::size = 0;
vector<int> Window::gap;

Window::Window()
{
    alt.resize(1);
    null.resize(0);
}

WindowResults::WindowResults()
{
    primary.resize(0);
    secondary.resize(0);    
}



void Driver::slideWindow_BASIC()
{

    int new_position = 1; 
    
    // Will the next Window be too far?
    if (Window::n > -1)
	new_position = win[Window::n]->pos + par::winstep;
    
 check_window_again:

    // end of all markers? 
    if ( new_position > Window::end) 
    {
	processWindow();
	exit(0);
    }
    
    // or just pushing up against a 'gap' ?
    for (int i=0; i < Window::gap.size(); i++)
    {
	
	// if edging over gap...
	if ( new_position + (Window::size-1) > Window::gap[i] )
	{
	    // shift to new position
	    new_position = Window::gap[i]+1;
	    
	    // invalidate this gap
	    Window::gap[i] = 9999999;
	    
	    // recheck
	    goto check_window_again;
	}
    }

    // Otherwise do a simple shift;
    Window::n++;
    
    // Create a new Window
    Window * temp_win = new Window;
    win.push_back(temp_win);
    
    // Set position
    win[Window::n]->pos = new_position;

    // Construct marker list
    win[Window::n]->alt.resize(alt.size());
    win[Window::n]->null.resize(null.size());

    for (int i=0; i< alt.size(); i++)
	win[Window::n]->alt[i] = win[Window::n]->pos + alt[i] -1;

    for (int i=0; i< null.size(); i++)
	win[Window::n]->null[i] = win[Window::n]->pos + null[i] -1;

    // Output title to cerr
    cerr << "Window position : ";
    for (int i=0; i < win[Window::n]->alt.size(); i++)
    {
	bool in_null = false;
	for (int j=0; j < win[Window::n]->null.size(); j++)
	    if (win[Window::n]->alt[i] == win[Window::n]->null[j]) 
		in_null = true;
	if (!in_null) cerr << " [" << win[Window::n]->alt[i] << "]";
	else cerr << " " << win[Window::n]->alt[i];
    }
    cerr << "\n";
    


    // Output title to cout if --allres
    if (par::win_all_results)
    {
	cout << "\n\nWindow position : ";
	for (int i=0; i < win[Window::n]->alt.size(); i++)
	{
	    bool in_null = false;
	    for (int j=0; j < win[Window::n]->null.size(); j++)
		if (win[Window::n]->alt[i] == win[Window::n]->null[j]) 
		    in_null = true;
	    if (!in_null) cout << " [" << win[Window::n]->alt[i] << "]";
	    else cout << " " << win[Window::n]->alt[i];
	}
	cout << "\n";
    }

    
}


void Driver::slideWindow_CONSTANT_HAP()
{
    ///
}
